
Redmine - Defect #14846
Calculation of the start date of following issues ignores the "non-working days" setting
2013-09-04 11:20 - Jeffrey Lee

Status: Closed Start date:
Priority: Normal Due date:
Assignee: Go MAEDA % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 4.0.0
Resolution: Fixed Affected version:
Description

I found following problem when set delay for one issue.
If the start date of the following issue is Saturday, the system will move the start date to next Monday automatically.
However, if the start date of the following issue is others (across the weekend), the system will not take non-working days into
consideration.
Please check the following example.
Is it a bug or my setting issue?

    -  Non-working in my system is Saturday and Sunday.
    -  Issue A: 2013/09/02(Mon.)~2013/09/03(Tue.)
    -  Set issue B follows issue A with N-days delay
        -  N=1, Issue B start date: 2013/09/05(Thu.) => Correct
        -  N=3, Issue B start date: 2013/09/09(Mon.) => Correct
        -  N=4, Issue B start date: 2013/09/09(Mon.) => Incorrect, SHOULD be 2013/09/10
        -  N=6, Issue B start date: 2013/09/10(Tue.) => Incorrect, SHOULD be 2013/09/12

System information:

Environment:
  Redmine version                2.3.2.stable
  Ruby version                   1.9.3-p448 (2013-06-27) [x86_64-linux]
  Rails version                  3.2.13
  Environment                    production
  Database adapter               Mysql2
Redmine plugins:
  clipboard_image_paste          1.7
  redmine_projects_accordion     0.1.0
  redmine_tab                    0.4.0
  redmine_theme_changer          0.1.0
  redmine_watcher_groups         0.0.2git
  redmine_work_time              0.2.8
  timelog_timer                  2.0.0

Related issues:
Related to Redmine - Defect # 29855: add_working_days returns wrong date Confirmed

Associated revisions
Revision 17230 - 2018-03-08 08:44 - Go MAEDA

Fix: Calculation of the start date of following issues ignores the "non-working days" setting (#14846).
Patch by Felix Schäfer.

History
#1 - 2013-09-17 08:35 - Toshi MARUYAMA
- Category set to Issues

#2 - 2014-03-10 23:14 - Felix Schäfer
- File 14846.patch added

One of our (Planio) customers noticed this bug too. We can confirm that the calculation of the start date of following issues does not take the
"non-working days" setting into account.

The attached patch solves this and adds a test for this behavior.

#3 - 2014-03-11 21:55 - Etienne Massip
- Target version set to Candidate for next minor release

#4 - 2018-02-26 10:43 - Go MAEDA
- File 14846-r17212.patch added
- Target version changed from Candidate for next minor release to 4.0.0

I have updated the patch for the current trunk (r17212).

Setting target version to 4.0.0.

#5 - 2018-03-08 08:46 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA
- Resolution set to Fixed

Committed. Thank you for your contribution.

#6 - 2018-03-08 08:46 - Go MAEDA
- Subject changed from Problem for setting issue B follows issue A with N-days delay to Calculation of the start date of following issues ignores the 
"non-working days" setting

#7 - 2018-10-28 02:46 - Go MAEDA
- Related to Defect #29855: add_working_days returns wrong date added

Files
14846.patch 3.25 KB 2014-03-10 Felix Schäfer
14846-r17212.patch 3.01 KB 2018-02-26 Go MAEDA
